#include <bits/stdc++.h>
using namespace std;
int N,Q;
long long d[300005],p[300005],q[300005];
int main(){
    scanf("%d %d",&N,&Q);
    memset(d,-1,sizeof(d));
    for(int i=1;i<=N;i++){
        scanf("%lld %lld",&d[i],&p[i]);
    }
    for(int i=1;i<=Q;i++){
        scanf("%lld",&q[i]);
    }
    int p1=1,p2=1;
    long long pojelasibambijastokodebela=0;
    while(p2<=Q){
        if(d[p1]==-1){
            for(int i=p2;i<=Q;i++){
                printf("%lld\n",pojelasibambijastokodebela);
            }
            break;
        }
        if(q[p2]<d[p1]){
            printf("%lld\n",pojelasibambijastokodebela);
            p2++;
            continue;
        }
        if(d[p1]>=q[p2-1]){
            long long eatable=q[p2]-d[p1]+1;
            if(p[p1]>eatable){
                pojelasibambijastokodebela+=eatable;
                p[p1]-=eatable;
                printf("%lld\n",pojelasibambijastokodebela);
                p2++;
            }
            else if(p[p1]==eatable){
                pojelasibambijastokodebela+=eatable;
                p[p1]=0;
                printf("%lld\n",pojelasibambijastokodebela);
                p1++;
                p2++;
            }
            else{
                pojelasibambijastokodebela+=p[p1];
                p[p1]=0;
                p1++;
            }
        }
        else{
            long long eatable=q[p2]-q[p2-1];
            if(p[p1]>eatable){
                pojelasibambijastokodebela+=eatable;
                p[p1]-=eatable;
                printf("%lld\n",pojelasibambijastokodebela);
                p2++;
            }
            else if(p[p1]==eatable){
                pojelasibambijastokodebela+=eatable;
                p[p1]=0;
                printf("%lld\n",pojelasibambijastokodebela);
                p1++;
                p2++;
            }
            else{
                pojelasibambijastokodebela+=p[p1];
                p[p1]=0;
                p1++;
            }
        }
    }
    return 0;
}